/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.staat.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class StaatUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String customCodeStaatsangehoerigkeit;

    public java.lang.String getCustomCodeStaatsangehoerigkeit(){
      return customCodeStaatsangehoerigkeit;
    }


  public StaatUK(
java.lang.String customCodeStaatsangehoerigkeit
  ) {
    super();


      this.customCodeStaatsangehoerigkeit = customCodeStaatsangehoerigkeit;
      }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((customCodeStaatsangehoerigkeit == null) ? 0 : customCodeStaatsangehoerigkeit.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            StaatUK other = (StaatUK) obj;

                if (customCodeStaatsangehoerigkeit == null) {
          if (other.customCodeStaatsangehoerigkeit != null) {
            return false;
          }
        } else if (!customCodeStaatsangehoerigkeit.equals(other.customCodeStaatsangehoerigkeit)) {
          return false;
        }
        
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return StaatConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StaatConstants.MESSAGE_KEY_ENTITY_EINZAHL, StaatConstants.MESSAGE_KEY_CODE_STAATSANGEHOERIGKEIT_EINZAHL, customCodeStaatsangehoerigkeit));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "StaatUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"customCodeStaatsangehoerigkeit="+customCodeStaatsangehoerigkeit
                                    ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(customCodeStaatsangehoerigkeit);
     return list;
   }

            public static <E extends Staat> java.util.Map<StaatUK, E> mappeStaatNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Staat::getStaatUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Staat, StaatUK> getStaatToUKFunction() {
                return Staat::getStaatUK;
                }

}
